SystemOrganization addCategory: #KEGUtilityStuff!

!Date methodsFor: '*KEGUtilityStuff' stamp: 'KjellGodo 10/15/2012 20:24'!
tradePrint

	"Method Version: keg1.  "
	"Copyright Kjell E God Oct 30 1996"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today Oct 30 1996"
	| monthNumber dayNumber yearNumber aStream |
										"( MT b:#tradePrint s:self )."
	aStream := WriteStream on: (String new: 8) .
	dayNumber := self dayOfMonth .
	monthNumber := self monthIndex .
	yearNumber := self year .   "<---------------------------( ORIGINAL-CODE-: yearNumber := self year \\ 100.   yearNumber < 10 ifTrue: [aStream nextPut: $0]. )"
	aStream nextPutAll: yearNumber displayString .
	monthNumber < 10 ifTrue: [aStream nextPut: $0] .
	aStream nextPutAll:(monthNumber displayString ) .
	dayNumber < 10 ifTrue: [aStream nextPut: $0] .
	aStream nextPutAll: (dayNumber displayString ) .
	^(
		( aStream contents )

	)"returning:(								MT e:#tradePrint s:self )"
									
	"Print the trading representation of self.  Which is of the form: YYYYMMDD."
! !

Array variableSubclass: #KEGFooArray
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGUtilityStuff'!

!KEGFooArray commentStamp: 'KjellGodo 10/14/2012 12:53' prior: 0!
KEGFooArray Class provides a meta structure Class that is used by Generators to 
	return meta values without returning nil( returning nil shuts down any KEGGenerator. ) to
	the  KEG Smalltalk software & software codes.
	Copyright  2000  Kjell E God

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.



	This is a null Class that is used by KEGGenerators to return null values without returning nil.

	This is because when a Generator returns nil it shuts down and only returns nil from then
	on( gen next = nil ).  
	Also other Objects besides Generators may want to use KEGFooArray in the same
	way.  An instance of KEGFooArray is an Array in case one of the Objects involved wants
	to return meta or status info about the sequence .  Although as of yet that has not been
	done very much.

	Thus the Class KEGFooArray may be in Generator sequences and instances of 
	KEGFooArray may be in Generator sequences.  When they are there they are to
	be ignored.  Or they could be used to transmit meta data about the sequence.  
	If you want to see how to use KEGGenerator>>collect:ignoring: or 
	KEGGenerator>>disperse: and KEGGenerator>>reject: without using KEGFooArray 
	itself to signal that nothing is to be returned as was the old way of doing things in the
	Smalltalk/V days then see KEGGenerator>>replaceAll:with: or KEGGenerator>>sortInto: .
	You do it by rejecting aKEGFooArray instead of rejecting the Class KEGFooArray as was done 
	in the past.  But the problem with doing it that old way was what if KEGFooArray were in 
	the Generator sequence and it came down the pike.  Then it would get confused with the 
	local use of KEGFooArray to say that nothing was to be returned.  But if we reject a 
	local instance of KEGFooArray instead of the Class KEGFooArray then the 
	KEGFooArrays in the Generator sequence are ignored just as they should be.

	Please note that KEGFooArray is used as a nil like element in Generators.  It is like a 
	space filler.  nil couldn't be used for this purpose because if nil occures in a Generator 
	then all the elements after that nil must also be nil.


!

Object subclass: #KEGEquivalenceCheck
	instanceVariableNames: 'equivalenceValuable hash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGUtilityStuff'!

!KEGEquivalenceCheck commentStamp: 'KjellGodo 10/14/2012 12:38' prior: 0!
KEGEquivalenceCheck can be used in simple parsers etc to check when two things are equivalent.
	Also you can do some small computations during the check if desired.  The idea is that
	you can match something to a sequence of things or to the action of a BlockClosure.

Instance Variables:
	equivalenceValuable	<BlockClosure | diadicValuable > respondsTo: #value:value: and tests the = .
	hash					<Integer> self This Class defines #= so we need a hash also for Dictionarys.
						
	KEGEquivalenceCheck Class allows arbitrary valuables to be evaluated
	in order to check if two Objects are equivalent via the #= message which
	is used a lot in Collections and such to see if an Object is in the Collection
	for the KEG Smalltalk software & software codes.
	Copyright  2011  Kjell E God


	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.


( comment:-- 20110501  This Class can be used with KEGGramarObjects to check if
	parse trees to be returned are complete etc.  Via the
	>>isDoneNonTerminals: message.  Also see the >>tokenMakerFunc: message which
	might also need to be used to switch the tokenMakerFunc temporarily and then
	back again.  Or if KEGGramarTokens are being used see the KEGGramarToken>>=
	method which shows how a KEGEquivalenceCheck can be used in place of a
	symbol.  If you used something more than a Symbol in the symbol slot of the
	KEGGramarToken then other things might also be done.
	KEGGramarObjects come from the KEGGeneratorParsing-6-0.pac Package
	( Dolphin Smalltalk ). )!

!KEGEquivalenceCheck methodsFor: 'testing' stamp: 'KjellGodo 10/14/2012 12:21'!
"(| defineMethod-:(" = anObject ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110501
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110501 17:19 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#= s:self )."
	^(
		( equivalenceValuable value: self value: anObject )

	)"return:( 					MT e:#= s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	See if self and anObject are equivalent or whatever you want to call it
	by evaluating the equivalenceValuable to check it out.

 )-summary
 methodDescriptionDetail-:(

	The equivalenceValuable is sent the >>value:value: message to see if
	self is equivalent to some other Object via the self>>= message.

	Actually the #= message can be an excuse to do arbitrary computations.

	See the KEGGramarToken>>= method for an example of how this can be
	done.  Basically you have to do something like
	=
		( ( anObject value ) = value ) or:[ 
		( value = ( anObject value ) ) ]

	because otherwise it is hard to do double dispatch for #= when there are
	a lot of things running around that don't participate in any double dispatch
	that you might come up with.  So just trying it both ways can be a hack
	for it.  Because if both of them are of the same Class or whatever then
	either way will return the same thing.  But if one is a KEGEquivalenceCheck
	then when it is the receiver then that case will return true or false and the
	other case will always return false( unless you have two KEGEquivalentceChecks
	which are the same Object ).

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGEquivalenceCheck methodsFor: 'testing' stamp: 'KjellGodo 10/14/2012 12:24'!
"(| defineMethod-:(" eqV: aDiadicValuable ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110506
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110506 13:24 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#eqV: s:self )."
	^(
		( self equivalenceValuable: aDiadicValuable )

	)"return:( 					MT e:#eqV: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	self This Method is a short version of the self>>equivalenceValuable:
	message for those times when you want a cleaner look.

 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGEquivalenceCheck methodsFor: 'testing' stamp: 'KjellGodo 10/14/2012 12:23'!
"(| defineMethod-:(" equivOr: aSequence ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110704
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110704 11:33 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#equivOr: s:self )."
	^(
		( self equivalenceValuable:[ :slf :obj | aSequence includes: obj ] )

	)"return:( 					MT e:#equivOr: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Make it so self will be = to any of the elements of aSequence.

 )-summary
 methodDescriptionDetail-:(
	detail
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGEquivalenceCheck methodsFor: 'testing' stamp: 'KjellGodo 10/14/2012 12:22'!
"(| defineMethod-:(" equivalenceValuable: aDiadicValuable ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110501
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110501 16:58 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#equivalenceValuable: s:self )."
	^(
		( equivalenceValuable := aDiadicValuable )

	)"return:( 					MT e:#equivalenceValuable: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Set the equivalenceValuable.

 )-summary
 methodDescriptionDetail-:(

	The equivalenceValuable is sent the >>value:value: message to see if
	self is equivalent to some other Object via the self>>= message.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGEquivalenceCheck methodsFor: 'testing' stamp: 'KjellGodo 10/14/2012 12:25'!
"(| defineMethod-:(" hash ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110504
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110504 9:50 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#hash s:self )."
	^(
		( hash )

	)"return:( 					MT e:#hash s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the hash of self.

 )-summary
 methodDescriptionDetail-:(

	The hash of self is used to place self into Dictionaries and such.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGEquivalenceCheck methodsFor: 'testing' stamp: 'KjellGodo 10/14/2012 12:26'!
"(| defineMethod-:(" hash: aHashNumber ")
	notes-:(		Method Version: keg1
				 Copyright Kjell E God 20110504
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20110504 9:48 )
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#hash: s:self )."
	^(
		( hash := aHashNumber )

	)"return:( 					MT e:#hash: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Set the hash of self.

 )-summary
 methodDescriptionDetail-:(

	The hash of self is used to place self into Dictionaries and such.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:(  ) madeChanges-:(  )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 designs-:(
	( DESIGN subject-:( aPackageName )of-:(
	)-of )-design
 )-designs
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

LinkedList subclass: #KEGFixedSizedQue
	instanceVariableNames: 'size'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGUtilityStuff'!

!KEGFixedSizedQue commentStamp: 'KjellGodo 10/14/2012 10:43' prior: 0!
Instance Variables:
	size	is the size of self if self was created properly using ( self size: anInteger )
		
	KEGFixedSizedQue Class provides a fixed size queue for
	the KEG Smalltalk software & software codes.
	Copyright (C) 2000  Kjell E God

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.
	
self This Class can be used to implement moving averages and such for the stock market.  You keep
doing >>addLast: and then >>inject:0into:... to get the moving average.

To step through a tutorial about how to use instances of self This Class select and debug the following-:

KEGFixedSizedQueTest new test.

This Class is meant to be used in the following way-:

First you make one-:

que := KEGFixedSizedQue new size: 10 .

And make a Generator on it.

gen := que asGenerator .

Then you fill it up with stuff.

stuff do:[ :x | que addLast: x ] .

Then you get the first thing off the que and add things onto the end of the que.

first := que first . que addLast: x .

or just keep adding things onto the end of the que and then when you want you can run the generator on it to iterate the contents of the que.

max := gen inject: nil into:[ :max :x | ( x <= max )ifTrue:[ max ]ifFalse:[ x ] ] .

So the initial use of this Que was to follow along a time sequence like a stock market time sequence for a stock or something.  So you could use a FixedSizeQue to always have the last 15 day of the time sequence and then you can do calculations on those last 15 days via the gen Generator or via any of the Collection iterators.  So you could do-:

max := que inject: nil into:[ :max :x | ( x <= max )ifTrue:[ max ]ifFalse:[ x ] ] .

cause you don't need the gen for that cause the Collection stuff can to >>inject:into: .  Alls you have to do is implement >>do: in a Collection subClass and then you get all of the Collection iterators too because internally they all do their iteration via the >>do: method.

So the FixedSizeQue will be used in the stock stuff a lot.  Because they get rid of the need to explicitly deal with the indexes into the sequences involved.




Like how about these ideas-:
Suppose you want to scan down a sequence S of Characters genOfCharacters and whenever you see 'abcde' in that sequence you want to open a Workspace that contains the sub sequences of S that is centered around 'abcde' and is 1000 Characters long. -:

gen1 := ( que1 := KEGFixedSizedQue new size: 500 ) asGenerator.
gen2 := ( que2 := KEGFixedSizedQue new size: 500 ) asGenerator.
gen := gen1 , gen2 .

( genOfCharacters collect:[ :x | 
	middle := que1 first . 
	que1 addLast: x .
	que2 addLast: middle
] )replaceAll:[:na| 'abcde' ] with:[:m| [ :m | gen asString edit . m ] ] .



Here is a simple test of the idea that works. -:
| que1 que2 |

que1 := KEGFixedSizedQue new size: 5 .

que2 := KEGFixedSizedQue new size: 5 .

'12345' do:[ :c | que1 addLast: c ] .
'67890' do:[ :c | que2 addLast: c ] .

( que1 asGen , que2 asGen ) asString = '1234567890' .!

!KEGFixedSizedQue methodsFor: 'adding' stamp: 'KjellGodo 10/13/2012 20:57'!
addFirst: anObject

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"

	self shouldNotImplement .
	
	"Not allowed.  use >>addLast: only."
! !

!KEGFixedSizedQue methodsFor: 'adding' stamp: 'KjellGodo 10/14/2012 09:43'!
addLast: anObject

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"
							"MT b:#addLast: s:self."

	super addLast:( ( self removeFirstLink ) contents: anObject ; yourself ) .

							"MT e:#addLast: s:self."
	^anObject .
	
	"Add anObject to the end of self.  When something is added to the end of self then
	something is always removed from the beginning of self.  Thus self is fixed size.
	Thus self is a first in last out Que with fixed size.  Which is useful for doing things with investing time
	sequences where you are traversing time series. [_]: A faster way to do it would be to make it a
	circular queue and just move the firstLink and lastLink ahead one and then change the contents
	of the first LinkCell.  Where lastLink next = firstLink is always true.  But here we just use the super
	Class's stuff."
! !

!KEGFixedSizedQue methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 21:04'!
first

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"
	| answer next |
											"MT b:#first s:self."

	( next := firstLink ) == nil ifTrue:[ ^( nil )"return:( MT e:#first s:self )" ] .
	( ( answer := next contents ) == nil )
		ifTrue:[ [ next notNil and:[ ( answer := next contents ) == nil ] ]
			whileTrue:[ next := next nextLink ] ] .

											"MT e:#first s:self."
	^answer .
	
	"Return the contents in the first non nil element in self.  Self will usually be full but initially it 
	won't be so we have to search for the first nonNil contents in self.  New elements should be added
	to self via self>>addLast: or self>>add: ."
! !

!KEGFixedSizedQue methodsFor: 'removing' stamp: 'KjellGodo 10/13/2012 21:08'!
removeFirst

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"

	"Not allowed.  self is fixed size.  You must use >>last to get objects out of self."

	self shouldNotImplement .! !

!KEGFixedSizedQue methodsFor: 'removing' stamp: 'KjellGodo 10/14/2012 09:42'!
"(| defineMethod-:(" removeFirstLink ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20121014
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint ( 20121014 9:41 )
	)-notes methodBody-:(
 (| let-:("| oldLink |")
    letBody-:("					"( MT b:#removeFirstLink s:self )."
	self emptyCheck.
	oldLink := firstLink.
	firstLink == lastLink
		ifTrue: [firstLink := nil. lastLink := nil]
		ifFalse: [firstLink := oldLink nextLink].
	oldLink nextLink: nil.
	^( 
		( oldLink )
	
	)"return:( 				MT e:#removeFirstLink s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Private - Remove the first Link and return the Link not the value in the Link.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGFixedSizedQue methodsFor: 'removing' stamp: 'KjellGodo 10/13/2012 21:09'!
removeLast

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"

	"Not allowed.  self is fixed size.  You must use >>last to get objects out of self."

	self shouldNotImplement .! !

!KEGFixedSizedQue methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 21:10'!
size

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"

							"MT b:#size s:self."

	size ifNil:[ size := 0 ] .

							"MT e:#size s:self."
	^size .

	"Return the size of self.  This value is only good if you use self as it is supposed to be used via only
	adding things to it via self>>addLast: and setting the size of self via self>>size: ."
! !

!KEGFixedSizedQue methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 21:21'!
size: sizeInteger

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"
	| answer addSize |
							"MT b:#size: s:self."

	( 0 = sizeInteger )ifTrue:[ ^( super removeAll )"return:( MT e:#size: s:self )" ] . "<---( Make self empty and cut all Links free. )"
	( sizeInteger = self size )ifTrue:[ ^( nil )"return:( MT e:#size: s:self )" ] .
	( 0 < sizeInteger )ifFalse:[ ^( nil )"return:( MT e:#size: s:self )" ] .

	( 0 < ( addSize := sizeInteger - ( self size ) ) )
		ifTrue:[ 1 to: addSize do:[ :na | super addFirst:( self theKEGLinkCellClass new ) ] ]
		ifFalse:[ 1 to:( addSize abs )do:[ :na | super isEmpty ifFalse:[ super removeFirst ] ] ] .
	size := sizeInteger .

							"MT e:#size: s:self."
							
	"Reset the size of self by either adding link cells or removing them.  
	nil is returned if no change is needed or if sizeInteger is negative.
	Otherwise self is returned."

! !

!KEGFixedSizedQue methodsFor: 'initialize-release' stamp: 'KjellGodo 10/13/2012 21:22'!
theKEGLinkCellClass

	"Method Version: keg1.  "
	" Copyright Kjell E God 20120623"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint ( 20120623 18:57 )"

	"Return the KEGLinkCell Class."
							"( MT b:#theKEGLinkCellClass s:self )."
	^(
		( KEGLinkCell )

	)"return:( 					MT e:#theKEGLinkCellClass s:self )"! !

ValueLink subclass: #KEGLinkCell
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'KEGUtilityStuff'!

!KEGLinkCell commentStamp: 'KjellGodo 10/13/2012 21:55' prior: 0!
KEGLinkCell Class provides some extensions to the Link Class
	which makes Links more like Lisp cons cells etc
	to the KEG Smalltalk software & software codes.
	Copyright  2003  Kjell E God

	This Class is licensed as MIT Open Source.  Please evaluate ( Object licenseMIT ) for more info
	or see KEGLicense class>>licenseMIT.

( comment:-- ( yyyymmdd 20030202 )

	If you make a list of KEGLinkCells then you can make a Generator out
	of it by just doing-:(
		( list := KEGLinkedListGenerator on: aKEGLinkCell )
	)which seems to be the most minimalistic way to get a Linked list to act like
	a sequence.  And then you can do-:(
		( KEGGenLispList on: list )
	)to get a KEGGenLispList out of it.  Because from here I can't see how to
	get a KEGGenLispList out of a KEGLinkCell list.
	And a KEGLinkedListGenerator may well be the fastest iterating Generator
	of the bunch because the next method is pretty minimal.  Well, maybe not.
	Maybe a KEGGenerator on a Stream on an Array is the fastest because of
	the Stream / Array speed optimizations.  But it is definitely the Generator that
	is the quickest to add elements into the center of.

 )---[ D:20030202 ]

!

!KEGLinkCell methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 21:28'!
"(| defineMethod-:(" contents ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20000814
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20000814
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#contents s:self )."
	^(
		( value )

	)"return:( 					MT e:#contents s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the contents of self.

 )-summary )-defineMethod"! !

!KEGLinkCell methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 21:29'!
"(| defineMethod-:(" contents: anObject ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20000814
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20000814
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#contents s:self )."
	^(
		( value := anObject )

	)"return:( 					MT e:#contents s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Return the contents of self.

 )-summary )-defineMethod"! !

!KEGLinkCell methodsFor: 'testing' stamp: 'KjellGodo 10/13/2012 21:31'!
isEmpty

	"Method Version: keg1.  "
	" Copyright Kjell E God 20000814"
	"licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details."
	"Date of Last Revision: Date today tradePrint 20000814"
							"MT b:#isEmpty s:self."
							"MT e:#isEmpty s:self."
	^value notNil .
	
	"Return a boolean.  True if self is set unbound or False if self is not unbound."
! !

!KEGLinkCell methodsFor: 'printing' stamp: 'KjellGodo 10/13/2012 21:37'!
"(| defineMethod-:(" printOn: aStream ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030216
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030216
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#printOn: s:self )."
	( super printOn:( aStream ) ).
	( aStream nextPutAll:( '--->' ) ).
	( self nextLink printOn:( aStream ) ).
	"^( self )return:( 				MT e:#printOn: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Print the representation of self that a programmer would want to see on aStream.

 )-summary
 methodDescriptionDetail-:(
	details
 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 alternateCode-:(
 )-alternateCode
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !

!KEGLinkCell methodsFor: 'accessing' stamp: 'KjellGodo 10/13/2012 21:39'!
"(| defineMethod-:(" value: anObject nextLink: aLink ")
	notes-:(		Method Version: keg1.
				 Copyright Kjell E God 20030201
	licensed as MIT Open Source: Please execute ( Object licenseMIT ) for details.
	Date of Last Revision: Date today tradePrint 20030201
	)-notes methodBody-:(
 (| let-:("		")
    letBody-:("					"( MT b:#value:nextLink: s:self )."

	( self value: anObject ; nextLink: aLink ).
	
	"^( self )return:( 			MT e:#value:nextLink: s:self )"

    ")-letbod )-let
 )-methBod
 methodDescriptionSummary-:(

	Set the value of self and the nextLink and then return self.

 )-summary
 methodDescriptionDetail-:(

	self must be returned.

 )-detail
 usage-:(
	usage
 )-usage
 todos-:(
	todos
 )-todos
 changes-:(
	(| KEG2-:( Changes onDate-:( ... ) madeChanges-:( ... )-madechanges )-chg )-keg2
 )-changes
 testCases-:(
	testCases
 )-testCases
 rants-:(
	rantsrantsrants rantsrants
 )-rants )-defineMethod"! !
